Attribute VB_Name = "opt"
Attribute VB_Description = "OPT reading module v1.0"
Public Enum vxCoordLetter
    vxX = 0
    vxY = 1
    vxZ = 2
End Enum

Public Enum tvxCoordLetter
    tvxU = 0
    tvxV = 1
End Enum

Public Enum vxnCoordLetter
    vxnI = 0
    vxnJ = 1
    vxnK = 2
End Enum

Public Enum hpProperty
    hpType = 0
    hpX = 1
    hpY = 2
    hpZ = 3
End Enum

Public Enum egProperty
    egCore = 0
    egOuter = 1
    egVector1 = 2
    egVector2 = 3
    egVector3 = 4
    egX = 5
    egY = 6
    egZ = 7
    egDensity1A = 8
    egDensity1B = 9
    egDensity1C = 10
    egDensity2A = 11
    egDensity2B = 12
    egDensity2C = 13
    egDensity3A = 14
    egDensity3B = 15
    egDensity3C = 16
End Enum

Public Enum hzProperty
    hzType = 0
    hzExpType = 1
    hzSpanX = 2
    hzSpanY = 3
    hzSpanZ = 4
    hzCenterX = 5
    hzCenterY = 6
    hzCenterZ = 7
    hzMinX = 8
    hzMinY = 9
    hzMinZ = 10
    hzMaxX = 11
    hzMaxY = 12
    hzMaxZ = 13
    hzTargetID = 14
    hzTargetX = 15
    hzTargetY = 16
    hzTargetZ = 17
End Enum

Public Enum rtProperty
    rtPivotX = 0
    rtPivotY = 1
    rtPivotZ = 2
    rtAxisX = 3
    rtAxisY = 4
    rtAxisZ = 5
    rtAimX = 6
    rtAimY = 7
    rtAimZ = 8
    rtDegreeX = 9
    rtDegreeY = 10
    rtDegreeZ = 11
End Enum

Public Enum fcProperty
    fcTexture = 0
    fcVertexA = 1
    fcVertexB = 2
    fcVertexC = 3
    fcVertexD = 4
    fcEdgeA = 5
    fcEdgeB = 6
    fcEdgeC = 7
    fcEdgeD = 8
    fcTexVertexA = 9
    fcTexVertexB = 10
    fcTexVertexC = 11
    fcTexVertexD = 12
    fcVertexNormalA = 13
    fcVertexNormalB = 14
    fcVertexNormalC = 15
    fcVertexNormalD = 16
    fcI = 17
    fcJ = 18
    fcK = 19
    fc1X = 20
    fc1Y = 21
    fc1Z = 22
    fc2X = 23
    fc2Y = 24
    fc2Z = 25
End Enum
Public Function FileSize(OptID As Variant) As Long
    Get OptID, 4 + 1, FileSize      'retrieve file size
    FileSize = FileSize + 8
End Function
Public Function GlobalOffset(OptID As Variant) As Long
    Get OptID, 8 + 1, GlobalOffset      'retrieve global offset
    GlobalOffset = GlobalOffset - 8     'modify global offset
End Function
Public Function NumMeshes(OptID As Variant) As Long
    Get OptID, 14 + 1, NumMeshes    'determine number of meshes
End Function
Public Function NumMeshSubs(OptID As Variant, MeshNum As Variant) As Long
    GlobeOffset& = GlobalOffset(OptID)
    MaxMesh = NumMeshes(OptID)
    If MeshNum > MaxMesh Or MeshNum < 1 Then    'if programmer inputs mesh that does not exist...
        Err.Raise vbObjectError + 701, , "Mesh does not exist in OPT"
    End If
    ScrollFile = 22
    Get OptID, ScrollFile + ((MeshNum - 1) * 4) + 1, ZJBMesh&
    ScrollFile = ZJBMesh& - GlobeOffset& + 8
    Get OptID, ScrollFile + 1, NumMeshSubs  'determine number of mesh subsections
End Function
Public Function ReverseOffset(OptID As Variant, MeshNum As Variant) As Long
    GlobeOffset& = GlobalOffset(OptID)
    MaxMesh = NumMeshes(OptID)
    If MeshNum > MaxMesh Or MeshNum < 1 Then    'if programmer inputs mesh that does not exist...
        Err.Raise vbObjectError + 701, , "Mesh does not exist in OPT"
    End If
    ScrollFile = 22
    Get OptID, ScrollFile + ((MeshNum - 1) * 4) + 1, ZJBMesh&
    ScrollFile = ZJBMesh& - GlobeOffset& + 20
    Get OptID, ScrollFile + 1, ReverseOffset    'retrieve reverse offset
End Function
Public Function IDMeshSub(OptID As Variant, MeshNum As Variant, MeshSubNum As Variant) As String
    GlobeOffset& = GlobalOffset(OptID)
    MaxMesh = NumMeshes(OptID)
    If MeshNum > MaxMesh Or MeshNum < 1 Then    'if programmer inputs mesh that does not exist...
        Err.Raise vbObjectError + 701, , "Mesh does not exist in OPT"
    End If
    ScrollFile = 22
    Get OptID, ScrollFile + ((MeshNum - 1) * 4) + 1, ZJBMesh&
    MaxMeshSub = NumMeshSubs(OptID, MeshNum)
    If MeshSubNum > MaxMeshSub Or MeshSubNum < 1 Then   'if programmer inputs mesh sub that does not exist...
        Err.Raise vbObjectError + 702, , "Mesh subsection does not exist in mesh"
    End If
    ScrollFile = ZJBMesh& - GlobeOffset& + 24
    Get OptID, ScrollFile + ((MeshSubNum - 1) * 4) + 1, ZJBMeshSub&
    If ZJBMeshSub& <> 0 Then    'if not a null subsection...
        ScrollFile = ZJBMeshSub& - GlobeOffset& + 4
        Get OptID, ScrollFile + 1, ZMeshType&
        If ZMeshType& <> 0 Then     'if other than mesh info(0) block...
            If ZMeshType& = 3 Then
                IDMeshSub = "[03]Vertices"
            ElseIf ZMeshType& = 13 Then
                IDMeshSub = "[13]Texture Vertices"
            ElseIf ZMeshType& = 11 Then
                IDMeshSub = "[11]Vertex Normals"
            ElseIf ZMeshType& = 22 Then
                IDMeshSub = "[22]Hardpoints"
            ElseIf ZMeshType& = 28 Then
                IDMeshSub = "[28]Engine Glows"
            ElseIf ZMeshType& = 25 Then
                IDMeshSub = "[25]Hitzone"
            ElseIf ZMeshType& = 23 Then
                IDMeshSub = "[23]Rotation"
            End If
        ElseIf ZMeshType& = 0 Then  'if mesh info(0) block
            ScrollFile = ScrollFile + 4
            Get OptID, ScrollFile + 1, ZMeshType&
            If ZMeshType& = 4 Then
                IDMeshSub = "[00]Mesh Info A"
            ElseIf ZMeshType& = 1 Then
                IDMeshSub = "[00]Mesh Info B"
            ElseIf ZMeshType& = 3 Then
                IDMeshSub = "[00]Mesh Info C"
            End If
        End If
    Else
        IDMeshSub = "NULL"
    End If
End Function
Public Function NumVertices(OptID As Variant, MeshNum As Variant) As Long
    GlobeOffset& = GlobalOffset(OptID)
    MaxMesh = NumMeshes(OptID)
    If MeshNum > MaxMesh Or MeshNum < 1 Then    'if programmer inputs mesh that does not exist...
        Err.Raise vbObjectError + 701, , "Mesh does not exist in OPT"
    End If
    ScrollFile = 22
    Get OptID, ScrollFile + ((MeshNum - 1) * 4) + 1, ZJBMesh&
    ZNumMeshSubs = NumMeshSubs(OptID, MeshNum)
    For ZScrollMeshSubs% = 1 To ZNumMeshSubs
        ScrollFile = ZJBMesh& - GlobeOffset& + 24
        Get OptID, ScrollFile + ((ZScrollMeshSubs% - 1) * 4) + 1, ZJBMeshSub&
        If ZJBMeshSub& <> 0 Then    'if not a null subsection...
            ScrollFile = ZJBMeshSub& - GlobeOffset& + 4
            Get OptID, ScrollFile + 1, ZMeshType&
            If ZMeshType& <> 0 Then     'if other than mesh info(0) block...
                If ZMeshType& = 3 Then
                    ScrollFile = ScrollFile + 12
                    Get OptID, ScrollFile + 1, NumVertices      'determine number of vertices
                End If
            End If
        End If
    Next
End Function
Public Function NumTexVertices(OptID As Variant, MeshNum As Variant) As Long
    GlobeOffset& = GlobalOffset(OptID)
    MaxMesh = NumMeshes(OptID)
    If MeshNum > MaxMesh Or MeshNum < 1 Then 'if programmer inputs mesh that does not exist...
        Err.Raise vbObjectError + 701, , "Mesh does not exist in OPT"
    End If
    ScrollFile = 22
    Get OptID, ScrollFile + ((MeshNum - 1) * 4) + 1, ZJBMesh&
    ZNumMeshSubs = NumMeshSubs(OptID, MeshNum)
    For ZScrollMeshSubs% = 1 To ZNumMeshSubs
        ScrollFile = ZJBMesh& - GlobeOffset& + 24
        Get OptID, ScrollFile + ((ZScrollMeshSubs% - 1) * 4) + 1, ZJBMeshSub&
        If ZJBMeshSub& <> 0 Then    'if not a null subsection...
            ScrollFile = ZJBMeshSub& - GlobeOffset& + 4
            Get OptID, ScrollFile + 1, ZMeshType&
            If ZMeshType& <> 0 Then     'if other than mesh info(0) block...
                If ZMeshType& = 13 Then
                    ScrollFile = ScrollFile + 12
                    Get OptID, ScrollFile + 1, NumTexVertices   'determine number of texture vertices
                End If
            End If
        End If
    Next
End Function
Public Function NumVertexNormals(OptID As Variant, MeshNum As Variant) As Long
    GlobeOffset& = GlobalOffset(OptID)
    MaxMesh = NumMeshes(OptID)
    If MeshNum > MaxMesh Or MeshNum < 1 Then    'if programmer inputs mesh that does not exist...
        Err.Raise vbObjectError + 701, , "Mesh does not exist in OPT"
    End If
    ScrollFile = 22
    Get OptID, ScrollFile + ((MeshNum - 1) * 4) + 1, ZJBMesh&
    ZNumMeshSubs = NumMeshSubs(OptID, MeshNum)
    For ZScrollMeshSubs% = 1 To ZNumMeshSubs
        ScrollFile = ZJBMesh& - GlobeOffset& + 24
        Get OptID, ScrollFile + ((ZScrollMeshSubs% - 1) * 4) + 1, ZJBMeshSub&
        If ZJBMeshSub& <> 0 Then    'if not a null subsection...
            ScrollFile = ZJBMeshSub& - GlobeOffset& + 4
            Get OptID, ScrollFile + 1, ZMeshType&
            If ZMeshType& <> 0 Then     'if other than mesh info(0) block...
                If ZMeshType& = 11 Then
                    ScrollFile = ScrollFile + 12
                    Get OptID, ScrollFile + 1, NumVertexNormals     'determine number of vertex normals
                End If
            End If
        End If
    Next
End Function
Public Function NumHardpoints(OptID As Variant, MeshNum As Variant) As Long
    NumHardpoints = 0   'start with zero hardpoints
    GlobeOffset& = GlobalOffset(OptID)
    MaxMesh = NumMeshes(OptID)
    If MeshNum > MaxMesh Or MeshNum < 1 Then    'if programmer inputs mesh that does not exist...
        Err.Raise vbObjectError + 701, , "Mesh does not exist in OPT"
    End If
    ScrollFile = 22
    Get OptID, ScrollFile + ((MeshNum - 1) * 4) + 1, ZJBMesh&
    ZNumMeshSubs = NumMeshSubs(OptID, MeshNum)
    For ZScrollMeshSubs% = 1 To ZNumMeshSubs
        ScrollFile = ZJBMesh& - GlobeOffset& + 24
        Get OptID, ScrollFile + ((ZScrollMeshSubs% - 1) * 4) + 1, ZJBMeshSub&
        If ZJBMeshSub& <> 0 Then    'if not a null subsection...
            ScrollFile = ZJBMeshSub& - GlobeOffset& + 4
            Get OptID, ScrollFile + 1, ZMeshType&
            If ZMeshType& <> 0 Then     'if other than mesh info(0) block...
                If ZMeshType& = 22 Then
                    NumHardpoints = NumHardpoints + 1   'increment hardpoint count
                End If
            End If
        End If
    Next
End Function
Public Function NumEngineGlows(OptID As Variant, MeshNum As Variant) As Long
    NumEngineGlows = 0  'start with zero engine glows
    GlobeOffset& = GlobalOffset(OptID)
    MaxMesh = NumMeshes(OptID)
    If MeshNum > MaxMesh Or MeshNum < 1 Then    'if programmer inputs mesh that does not exist...
        Err.Raise vbObjectError + 701, , "Mesh does not exist in OPT"
    End If
    ScrollFile = 22
    Get OptID, ScrollFile + ((MeshNum - 1) * 4) + 1, ZJBMesh&
    ZNumMeshSubs = NumMeshSubs(OptID, MeshNum)
    For ZScrollMeshSubs% = 1 To ZNumMeshSubs
        ScrollFile = ZJBMesh& - GlobeOffset& + 24
        Get OptID, ScrollFile + ((ZScrollMeshSubs% - 1) * 4) + 1, ZJBMeshSub&
        If ZJBMeshSub& <> 0 Then    'if not a null subsection...
            ScrollFile = ZJBMeshSub& - GlobeOffset& + 4
            Get OptID, ScrollFile + 1, ZMeshType&
            If ZMeshType& <> 0 Then     'if other than mesh info(0) block...
                If ZMeshType& = 28 Then
                    NumEngineGlows = NumEngineGlows + 1     'increment engine glow count
                End If
            End If
        End If
    Next
End Function
Public Function NumLODs(OptID As Variant, MeshNum As Variant) As Long
    GlobeOffset& = GlobalOffset(OptID)
    MaxMesh = NumMeshes(OptID)
    If MeshNum > MaxMesh Or MeshNum < 1 Then    'if programmer inputs mesh that does not exist...
        Err.Raise vbObjectError + 701, , "Mesh does not exist in OPT"
    End If
    ScrollFile = 22
    Get OptID, ScrollFile + ((MeshNum - 1) * 4) + 1, ZJBMesh&
    ZNumMeshSubs = NumMeshSubs(OptID, MeshNum)
    For ZScrollMeshSubs% = 1 To ZNumMeshSubs
        ScrollFile = ZJBMesh& - GlobeOffset& + 24
        Get OptID, ScrollFile + ((ZScrollMeshSubs% - 1) * 4) + 1, ZJBMeshSub&
        If ZJBMeshSub& <> 0 Then    'if not a null subsection...
            ScrollFile = ZJBMeshSub& - GlobeOffset& + 4
            Get OptID, ScrollFile + 1, ZMeshType&
            If ZMeshType& = 0 Then  'if mesh info(0) block...
                ScrollFile = ScrollFile + 4
                Get OptID, ScrollFile + 1, ZMeshType&
                If ZMeshType& = 4 Then
                    ScrollFile = ScrollFile + 28
                ElseIf ZMeshType& = 1 Then
                    ScrollFile = ScrollFile + 16
                ElseIf ZMeshType& = 3 Then
                    ScrollFile = ScrollFile + 24
                End If
                Get OptID, ScrollFile + 1, ZJB21Block&
                ScrollFile = ZJB21Block& - GlobeOffset& + 8
                Get OptID, ScrollFile + 1, NumLODs  'determine number of detail levels
            End If
        End If
    Next
End Function
Public Function NumFaces(OptID As Variant, MeshNum As Variant, LODNum As Variant, FaceDataNum As Variant) As Long
    FaceFind = 0
    GlobeOffset& = GlobalOffset(OptID)
    MaxMesh = NumMeshes(OptID)
    If MeshNum > MaxMesh Or MeshNum < 1 Then    'if programmer inputs mesh that does not exist...
        Err.Raise vbObjectError + 701, , "Mesh does not exist in OPT"
    End If
    ScrollFile = 22
    Get OptID, ScrollFile + ((MeshNum - 1) * 4) + 1, ZJBMesh&
    ZNumMeshSubs = NumMeshSubs(OptID, MeshNum)
    For ZScrollMeshSubs% = 1 To ZNumMeshSubs
        ScrollFile = ZJBMesh& - GlobeOffset& + 24
        Get OptID, ScrollFile + ((ZScrollMeshSubs% - 1) * 4) + 1, ZJBMeshSub&
        If ZJBMeshSub& <> 0 Then
            ScrollFile = ZJBMeshSub& - GlobeOffset& + 4
            Get OptID, ScrollFile + 1, ZMeshType&
            If ZMeshType& = 0 Then     'if mesh info(0) block...
                ScrollFile = ScrollFile + 4
                Get OptID, ScrollFile + 1, ZMeshType&
                If ZMeshType& = 4 Then
                    ScrollFile = ScrollFile + 28
                ElseIf ZMeshType& = 1 Then
                    ScrollFile = ScrollFile + 16
                ElseIf ZMeshType& = 3 Then
                    ScrollFile = ScrollFile + 24
                End If
                Get OptID, ScrollFile + 1, ZJB21Block&
                 ScrollFile = ZJB21Block& - GlobeOffset& + 8
                 Get OptID, ScrollFile + 1, ZNumLODs&
                 ScrollFile = ZJB21Block& - GlobeOffset& + 12
                 Get OptID, ScrollFile + 1, ZJJLODs&
                MaxLOD = NumLODs(OptID, MeshNum)
                If LODNum > MaxLOD Or LODNum < 1 Then   'if programmer inputs detail level that does not exist...
                    Err.Raise vbObjectError + 703, , "Detail level does not exist in mesh"
                End If
                 ScrollFile = ZJJLODs& - GlobeOffset&
                 Get OptID, ScrollFile + ((LODNum - 1) * 4) + 1, ZJBLOD&
                 ScrollFile = ZJBLOD& - GlobeOffset& + 8
                 Get OptID, ScrollFile + 1, ZNumFaceGroups&
                MaxFaceData = NumFaceData(OptID, MeshNum, LODNum)
                If FaceDataNum > MaxFaceData Or FaceDataNum < 1 Then    'if programmer inputs face data group that does not exist...
                    Err.Raise vbObjectError + 704, , "Face data group does not exist in detail level"
                End If
                ScrollFile = ZJBLOD& - GlobeOffset& + 24
                Get OptID, ScrollFile + ((FaceDataNum - 1) * 4) + 1, ZJBFaceGroup&
                If ZJBFaceGroup& <> 0 Then      'if not a null subsection...
                    ScrollFile = ZJBFaceGroup& - GlobeOffset& + 4
                    Get OptID, ScrollFile + 1, ZFaceGroupType&
                    If ZFaceGroupType& = 1 Then    'if face block(1)
                       ScrollFile = ScrollFile + 12
                       Get OptID, ScrollFile + 1, NumFaces     'determine number of faces
                    End If
                End If
            End If
        End If
    Next
End Function
Public Function NumFaceData(OptID As Variant, MeshNum As Variant, LODNum As Variant) As Long
    GlobeOffset& = GlobalOffset(OptID)
    MaxMesh = NumMeshes(OptID)
    If MeshNum > MaxMesh Or MeshNum < 1 Then    'if programmer inputs mesh that does not exist...
        Err.Raise vbObjectError + 701, , "Mesh does not exist in OPT"
    End If
    ScrollFile = 22
    Get OptID, ScrollFile + ((MeshNum - 1) * 4) + 1, ZJBMesh&
    ZNumMeshSubs = NumMeshSubs(OptID, MeshNum)
    For ZScrollMeshSubs% = 1 To ZNumMeshSubs
        ScrollFile = ZJBMesh& - GlobeOffset& + 24
        Get OptID, ScrollFile + ((ZScrollMeshSubs% - 1) * 4) + 1, ZJBMeshSub&
        If ZJBMeshSub& <> 0 Then
            ScrollFile = ZJBMeshSub& - GlobeOffset& + 4
            Get OptID, ScrollFile + 1, ZMeshType&
            If ZMeshType& = 0 Then  'if mesh info(0) block...
                ScrollFile = ScrollFile + 4
                Get OptID, ScrollFile + 1, ZMeshType&
                If ZMeshType& = 4 Then
                    ScrollFile = ScrollFile + 28
                ElseIf ZMeshType& = 1 Then
                    ScrollFile = ScrollFile + 16
                ElseIf ZMeshType& = 3 Then
                    ScrollFile = ScrollFile + 24
                End If
                Get OptID, ScrollFile + 1, ZJB21Block&
                ScrollFile = ZJB21Block& - GlobeOffset& + 12
                Get OptID, ScrollFile + 1, ZJJLODs&
                MaxLOD = NumLODs(OptID, MeshNum)
                If LODNum > MaxLOD Or LODNum < 1 Then   'if programmer inputs detail level that does not exist...
                    Err.Raise vbObjectError + 703, , "Detail level does not exist in mesh"
                End If
                ScrollFile = ZJJLODs& - GlobeOffset&
                Get OptID, ScrollFile + ((LODNum - 1) * 4) + 1, ZJBLOD&
                ScrollFile = ZJBLOD& - GlobeOffset& + 8
                Get OptID, ScrollFile + 1, NumFaceData  'determine number of face data groups
            End If
        End If
    Next
End Function
Public Function IDFaceData(OptID As Variant, MeshNum As Variant, LODNum As Variant, FaceDataNum As Variant) As String
    GlobeOffset& = GlobalOffset(OptID)
    MaxMesh = NumMeshes(OptID)
    If MeshNum > MaxMesh Or MeshNum < 1 Then    'if programmer inputs mesh that does not exist...
        Err.Raise vbObjectError + 701, , "Mesh does not exist in OPT"
    End If
    ScrollFile = 22
    Get OptID, ScrollFile + ((MeshNum - 1) * 4) + 1, ZJBMesh&
    ZNumMeshSubs = NumMeshSubs(OptID, MeshNum)
    For ZScrollMeshSubs% = 1 To ZNumMeshSubs
        ScrollFile = ZJBMesh& - GlobeOffset& + 24
        Get OptID, ScrollFile + ((ZScrollMeshSubs% - 1) * 4) + 1, ZJBMeshSub&
        If ZJBMeshSub& <> 0 Then    'if not a null subsection...
            ScrollFile = ZJBMeshSub& - GlobeOffset& + 4
            Get OptID, ScrollFile + 1, ZMeshType&
            If ZMeshType& = 0 Then  'if mesh info(0) block...
                ScrollFile = ScrollFile + 4
                Get OptID, ScrollFile + 1, ZMeshType&
                If ZMeshType& = 4 Then
                    ScrollFile = ScrollFile + 28
                ElseIf ZMeshType& = 1 Then
                    ScrollFile = ScrollFile + 16
                ElseIf ZMeshType& = 3 Then
                    ScrollFile = ScrollFile + 24
                End If
                Get OptID, ScrollFile + 1, ZJB21Block&
                ScrollFile = ZJB21Block& - GlobeOffset& + 12
                Get OptID, ScrollFile + 1, ZJJLODs&
                MaxLOD = NumLODs(OptID, MeshNum)
                If LODNum > MaxLOD Or LODNum < 1 Then   'if programmer inputs detail level that does not exist...
                    Err.Raise vbObjectError + 703, , "Detail level does not exist in mesh"
                End If
                ScrollFile = ZJJLODs& - GlobeOffset&
                Get OptID, ScrollFile + ((LODNum - 1) * 4) + 1, ZJBLOD&
                MaxFaceData = NumFaceData(OptID, MeshNum, LODNum)
                If ZScrollMeshes% = MeshNum And ZScrollLODs% = LODNum Then
                    If FaceDataNum > MaxFaceData Or FaceDataNum < 1 Then    'if programmer inputs face data group that does not exist...
                        Err.Raise vbObjectError + 704, , "Face data group does not exist in detail level"
                    End If
                End If
                ScrollFile = ZJBLOD& - GlobeOffset& + 24
                Get OptID, ScrollFile + ((FaceDataNum - 1) * 4) + 1, ZJBFaceData&
                If ZJBFaceData& <> 0 Then      'if not a null face data group
                    ScrollFile = ZJBFaceData& - GlobeOffset& + 4
                    Get OptID, ScrollFile + 1, ZFaceDataType&
                    If ZFaceDataType& = 20 Then    'if texture block(20)
                        ScrollFile = ScrollFile + 4
                        Get OptID, ScrollFile + 1, ZFaceDataType&
                        If ZFaceDataType& = 0 Then    'if type AAA texture block(20)
                            IDFaceData = "[20]Texture AAA"
                        ElseIf ZFaceDataType& = 1 Then 'if type AA texture block(20)
                            IDFaceData = "[20]Texture AA"
                        End If
                    ElseIf ZFaceDataType& = 24 Then    'if texture block(24)
                        ScrollFile = ScrollFile + 4
                        Get OptID, ScrollFile + 1, ZFaceDataType&
                        If ZFaceDataType& <> 1 Then    'if texture block(24) C or CCC
                            ScrollFile = ScrollFile + 8
                            Get OptID, ScrollFile + 1, ZFaceDataType&
                            If ZFaceDataType& = 1 Then 'if texture block(24) C
                                IDFaceData = "[24]Texture Group C"
                            ElseIf ZFaceDataType& = 0 Then     'if texture block(24) CCC
                                IDFaceData = "[24]Texture Group CCC"
                            End If
                        ElseIf ZFaceDataType& = 1 Then     'if texture block(24) CC
                            IDFaceData = "[24]Texture Group CC"
                        End If
                    ElseIf ZFaceDataType& = 7 Then
                        IDFaceData = "[07]Texture B"
                    ElseIf ZFaceDataType& = 1 Then
                        IDFaceData = "[01]Face Info"
                    End If
                End If
            End If
        End If
    Next
End Function
Public Function GetVertex(OptID As Variant, MeshNum As Variant, CoordSet As Variant, CoordLetter As vxCoordLetter) As Single
    GlobeOffset& = GlobalOffset(OptID)
    MaxMesh = NumMeshes(OptID)
    If MeshNum > MaxMesh Or MeshNum < 1 Then    'if programmer inputs mesh that does not exist...
        Err.Raise vbObjectError + 701, , "Mesh does not exist in OPT"
    End If
    ScrollFile = 22
    Get OptID, ScrollFile + ((MeshNum - 1) * 4) + 1, ZJBMesh&
    ZNumMeshSubs = NumMeshSubs(OptID, MeshNum)
    For ZScrollMeshSubs% = 1 To ZNumMeshSubs
        ScrollFile = ZJBMesh& - GlobeOffset& + 24
        Get OptID, ScrollFile + ((ZScrollMeshSubs% - 1) * 4) + 1, ZJBMeshSub&
        If ZJBMeshSub& <> 0 Then    'if not a null data block...
            ScrollFile = ZJBMeshSub& - GlobeOffset& + 4
            Get OptID, ScrollFile + 1, ZMeshType&
            If ZMeshType& <> 0 Then    'if other than mesh info(0) block...
                If ZMeshType& = 3 Then
                    ScrollFile = ScrollFile + 20
                    MaxValue = NumVertices(OptID, MeshNum)
                    If CoordSet > MaxValue Or CoordSet < 1 Then     'if programmer inputs vertex set that does not exist...
                        Err.Raise vbObjectError + 711, , "Vertex does not exist in mesh"
                    End If
                    If CoordLetter > 2 Or CoordLetter < 0 Then      'if programmer inputs property that does not exist...
                        Err.Raise vbObjectError + 721, , "Invalid CoordLetter"
                    End If
                    Get OptID, ScrollFile + (CoordSet - 1) * 12 + (CoordLetter * 4) + 1, GetVertex  'retrieve vertex coordinate
                End If
            End If
        End If
    Next
End Function
Public Function GetTexVertex(OptID As Variant, MeshNum As Variant, CoordSet As Variant, CoordLetter As tvxCoordLetter) As Single
    GlobeOffset& = GlobalOffset(OptID)
    MaxMesh = NumMeshes(OptID)
    If MeshNum > MaxMesh Or MeshNum < 1 Then    'if programmer inputs mesh that does not exist...
        Err.Raise vbObjectError + 701, , "Mesh does not exist in OPT"
    End If
    ScrollFile = 22
    Get OptID, ScrollFile + ((MeshNum - 1) * 4) + 1, ZJBMesh&
    ZNumMeshSubs = NumMeshSubs(OptID, MeshNum)
    For ZScrollMeshSubs% = 1 To ZNumMeshSubs
        ScrollFile = ZJBMesh& - GlobeOffset& + 24
        Get OptID, ScrollFile + ((ZScrollMeshSubs% - 1) * 4) + 1, ZJBMeshSub&
        If ZJBMeshSub& <> 0 Then    'if not a null subsection...
            ScrollFile = ZJBMeshSub& - GlobeOffset& + 4
            Get OptID, ScrollFile + 1, ZMeshType&
            If ZMeshType& <> 0 Then 'if other than mesh info(0) block...
                If ZMeshType& = 13 Then
                    ScrollFile = ScrollFile + 20
                    MaxValue = NumTexVertices(OptID, MeshNum)
                    If CoordSet > MaxValue Or CoordSet < 1 Then     'if programmer inputs texture vertex set that does not exist...
                        Err.Raise vbObjectError + 712, , "Texture vertex does not exist in mesh"
                    End If
                    If CoordLetter > 1 Or CoordLetter < 0 Then      'if programmer inputs property that does not exist...
                        Err.Raise vbObjectError + 721, , "Invalid CoordLetter"
                    End If
                    Get OptID, ScrollFile + (CoordSet - 1) * 8 + (CoordLetter * 4) + 1, GetTexVertex    'retrieve texture vertex coordinate
                End If
            End If
        End If
    Next
End Function
Public Function GetVertexNormal(OptID As Variant, MeshNum As Variant, CoordSet As Variant, CoordLetter As vxnCoordLetter) As Single
    GlobeOffset& = GlobalOffset(OptID)
    MaxMesh = NumMeshes(OptID)
    If MeshNum > MaxMesh Or MeshNum < 1 Then    'if programmer inputs mesh that does not exist...
        Err.Raise vbObjectError + 701, , "Mesh does not exist in OPT"
    End If
    ScrollFile = 22
    Get OptID, ScrollFile + ((MeshNum - 1) * 4) + 1, ZJBMesh&
    ZNumMeshSubs = NumMeshSubs(OptID, MeshNum)
    For ZScrollMeshSubs% = 1 To ZNumMeshSubs
        ScrollFile = ZJBMesh& - GlobeOffset& + 24
        Get OptID, ScrollFile + ((ZScrollMeshSubs% - 1) * 4) + 1, ZJBMeshSub&
        If ZJBMeshSub& <> 0 Then    'if not a null subsection...
            ScrollFile = ZJBMeshSub& - GlobeOffset& + 4
            Get OptID, ScrollFile + 1, ZMeshType&
            If ZMeshType& <> 0 Then  'if other than mesh info(0) block...
                If ZMeshType& = 11 Then
                    ScrollFile = ScrollFile + 20
                    MaxValue = NumVertexNormals(OptID, MeshNum)
                    If CoordSet > MaxValue Or CoordSet < 1 Then     'if programmer inputs vertex normal set that does not exist...
                        Err.Raise vbObjectError + 713, , "Vertex normal does not exist in mesh"
                    End If
                    If CoordLetter > 2 Or CoordLetter < 0 Then      'if programmer inputs property that does not exist...
                        Err.Raise vbObjectError + 721, , "Invalid CoordLetter"
                    End If
                    Get OptID, ScrollFile + (CoordSet - 1) * 12 + (CoordLetter * 4) + 1, GetVertexNormal    'retrieve vertex normal coordinate
                End If
            End If
        End If
    Next
End Function
Public Function GetHardpoint(OptID As Variant, MeshNum As Variant, HPSet As Variant, SelProperty As hpProperty) As Variant
    HPFind = 0  'start with zero hardpoints
    GlobeOffset& = GlobalOffset(OptID)
    MaxMesh = NumMeshes(OptID)
    If MeshNum > MaxMesh Or MeshNum < 1 Then    'if programmer inputs mesh that does not exist...
        Err.Raise vbObjectError + 701, , "Mesh does not exist in OPT"
    End If
    ScrollFile = 22
    Get OptID, ScrollFile + ((MeshNum - 1) * 4) + 1, ZJBMesh&
    ZNumMeshSubs = NumMeshSubs(OptID, MeshNum)
    For ZScrollMeshSubs% = 1 To ZNumMeshSubs
        ScrollFile = ZJBMesh& - GlobeOffset& + 24
        Get OptID, ScrollFile + ((ZScrollMeshSubs% - 1) * 4) + 1, ZJBMeshSub&
        If ZJBMeshSub& <> 0 Then    'if not a null subsection...
            ScrollFile = ZJBMeshSub& - GlobeOffset& + 4
            Get OptID, ScrollFile + 1, ZMeshType&
            If ZMeshType& <> 0 Then     'if other than mesh info(0) block
                MaxValue = NumHardpoints(OptID, MeshNum)
                If HPSet > MaxValue Or HPSet < 1 Then   'if programmer inputs hardpoint that does not exist...
                    Err.Raise vbObjectError + 714, , "Hardpoint does not exist in mesh"
                End If
                If SelProperty > 3 Or SelProperty < 0 Then      'if programmer inputs property that does not exist...
                    Err.Raise vbObjectError + 722, , "Invalid SelProperty"
                End If
                If ZMeshType& = 22 Then
                    HPFind = HPFind + 1     'increment hardpoint count
                    If HPFind = HPSet Then
                        If SelProperty = hpType Then
                            ScrollFile = ScrollFile + 20
                            Get OptID, ScrollFile + 1, GetHPL&
                            Select Case GetHPL&
                                Case 0
                                    GetHPS$ = "[0]None"
                                Case 1
                                    GetHPS$ = "[1]RebelLaser"
                                Case 2
                                    GetHPS$ = "[2]TurboRebelLaser"
                                Case 3
                                    GetHPS$ = "[3]EmpireLaser"
                                Case 4
                                    GetHPS$ = "[4]TurboEmpireLaser"
                                Case 5
                                    GetHPS$ = "[5]IonCannon"
                                Case 6
                                    GetHPS$ = "[6]TurboIonCannon"
                                Case 7
                                    GetHPS$ = "[7]Torpedo"
                                Case 8
                                    GetHPS$ = "[8]Missile"
                                Case 9
                                    GetHPS$ = "[9]SuperRebelLaser"
                                Case 10
                                    GetHPS$ = "[10]SuperEmpireLaser"
                                Case 11
                                    GetHPS$ = "[11]SuperIonCannon"
                                Case 12
                                    GetHPS$ = "[12]SuperTorpedo"
                                Case 13
                                    GetHPS$ = "[13]SuperMissile"
                                Case 14
                                    GetHPS$ = "[14]DumbBomb"
                                Case 15
                                    GetHPS$ = "[15]FiredBomb"
                                Case 16
                                    GetHPS$ = "[16]MagPulse"
                                Case 17
                                    GetHPS$ = "[17]TurboMagPulse"
                                Case 18
                                    GetHPS$ = "[18]SuperMagPulse"
                                Case 19
                                    GetHPS$ = "[19]NewWeapon1"
                                Case 20
                                    GetHPS$ = "[20]NewWeapon2"
                                Case 21
                                    GetHPS$ = "[21]NewWeapon3"
                                Case 22
                                    GetHPS$ = "[22]NewWeapon4"
                                Case 23
                                    GetHPS$ = "[23]NewWeapon5"
                                Case 24
                                    GetHPS$ = "[24]NewWeapon6"
                                Case 25
                                    GetHPS$ = "[25]InsideHangar"
                                Case 26
                                    GetHPS$ = "[26]OutsideHangar"
                                Case 27
                                    GetHPS$ = "[27]DockFromBig"
                                Case 28
                                    GetHPS$ = "[28]DockFromSmall"
                                Case 29
                                    GetHPS$ = "[29]DockToBig"
                                Case 30
                                    GetHPS$ = "[30]DockToSmall"
                                Case 31
                                    GetHPS$ = "[31]Cockpit"
                            End Select
                            GetHardpoint = GetHPS$
                        ElseIf SelProperty = hpX Then
                            ScrollFile = ScrollFile + 24
                            Get OptID, ScrollFile + 1, GetHPF!
                            GetHardpoint = GetHPF!
                        ElseIf SelProperty = hpY Then
                            ScrollFile = ScrollFile + 28
                            Get OptID, ScrollFile + 1, GetHPF!
                            GetHardpoint = GetHPF!
                        ElseIf SelProperty = hpZ Then
                            ScrollFile = ScrollFile + 32
                            Get OptID, ScrollFile + 1, GetHPF!
                            GetHardpoint = GetHPF!
                        End If
                    End If
                End If
            End If
        End If
    Next
End Function
Public Function GetEngineGlow(OptID As Variant, MeshNum As Variant, EGSet As Variant, SelProperty As egProperty) As Variant
    EGFind = 0  'start with zero engine glows
    GlobeOffset& = GlobalOffset(OptID)
    MaxMesh = NumMeshes(OptID)
    If MeshNum > MaxMesh Or MeshNum < 1 Then    'if programmer inputs mesh that does not exist...
        Err.Raise vbObjectError + 701, , "Mesh does not exist in OPT"
    End If
    ScrollFile = 22
    Get OptID, ScrollFile + ((MeshNum - 1) * 4) + 1, ZJBMesh&
    ZNumMeshSubs = NumMeshSubs(OptID, MeshNum)
    For ZScrollMeshSubs% = 1 To ZNumMeshSubs
        ScrollFile = ZJBMesh& - GlobeOffset& + 24
        Get OptID, ScrollFile + ((ZScrollMeshSubs% - 1) * 4) + 1, ZJBMeshSub&
        If ZJBMeshSub& <> 0 Then    'if not a null subsection...
            ScrollFile = ZJBMeshSub& - GlobeOffset& + 4
            Get OptID, ScrollFile + 1, ZMeshType&
            If ZMeshType& <> 0 Then     'if other than mesh info(0) block...
                MaxValue = NumEngineGlows(OptID, MeshNum)
                If EGSet > MaxValue Or EGSet < 1 Then   'if programmer inputs engine glow that does not exist...
                    Err.Raise vbObjectError + 715, , "Engine glow does not exist in mesh"
                End If
                If SelProperty > 16 Or SelProperty < 0 Then     'if programmer inputs property that does not exist...
                    Err.Raise vbObjectError + 722, , "Invalid SelProperty"
                End If
                If ZMeshType& = 28 Then
                    EGFind = EGFind + 1
                    If EGFind = EGSet Then
                        If SelProperty = egCore Then
                            ScrollFile = ScrollFile + 24
                            Get OptID, ScrollFile + 1, GetEGL&
                            GetEngineGlow = GetEGL&
                        ElseIf SelProperty = egOuter Then
                            ScrollFile = ScrollFile + 28
                            Get OptID, ScrollFile + 1, GetEGL&
                            GetEngineGlow = GetEGL&
                        ElseIf SelProperty = egVector1 Then
                            ScrollFile = ScrollFile + 32
                            Get OptID, ScrollFile + 1, GetEGF!
                            GetEngineGlow = GetEGF!
                        ElseIf SelProperty = egVector2 Then
                            ScrollFile = ScrollFile + 36
                            Get OptID, ScrollFile + 1, GetEGF!
                            GetEngineGlow = GetEGF!
                        ElseIf SelProperty = egVector3 Then
                            ScrollFile = ScrollFile + 40
                            Get OptID, ScrollFile + 1, GetEGF!
                            GetEngineGlow = GetEGF!
                        ElseIf SelProperty = egX Then
                            ScrollFile = ScrollFile + 44
                            Get OptID, ScrollFile + 1, GetEGF!
                            GetEngineGlow = GetEGF!
                        ElseIf SelProperty = egY Then
                            ScrollFile = ScrollFile + 48
                            Get OptID, ScrollFile + 1, GetEGF!
                            GetEngineGlow = GetEGF!
                        ElseIf SelProperty = egZ Then
                            ScrollFile = ScrollFile + 52
                            Get OptID, ScrollFile + 1, GetEGF!
                            GetEngineGlow = GetEGF!
                        ElseIf SelProperty = egDensity1A Then
                            ScrollFile = ScrollFile + 56
                            Get OptID, ScrollFile + 1, GetEGF!
                            GetEngineGlow = GetEGF!
                        ElseIf SelProperty = egDensity1B Then
                            ScrollFile = ScrollFile + 60
                            Get OptID, ScrollFile + 1, GetEGF!
                            GetEngineGlow = GetEGF!
                        ElseIf SelProperty = egDensity1C Then
                            ScrollFile = ScrollFile + 64
                            Get OptID, ScrollFile + 1, GetEGF!
                            GetEngineGlow = GetEGF!
                        ElseIf SelProperty = egDensity2A Then
                            ScrollFile = ScrollFile + 68
                            Get OptID, ScrollFile + 1, GetEGF!
                            GetEngineGlow = GetEGF!
                        ElseIf SelProperty = egDensity2B Then
                            ScrollFile = ScrollFile + 72
                            Get OptID, ScrollFile + 1, GetEGF!
                            GetEngineGlow = GetEGF!
                        ElseIf SelProperty = egDensity2C Then
                            ScrollFile = ScrollFile + 76
                            Get OptID, ScrollFile + 1, GetEGF!
                            GetEngineGlow = GetEGF!
                        ElseIf SelProperty = egDensity3A Then
                            ScrollFile = ScrollFile + 80
                            Get OptID, ScrollFile + 1, GetEGF!
                            GetEngineGlow = GetEGF!
                        ElseIf SelProperty = egDensity3B Then
                            ScrollFile = ScrollFile + 84
                            Get OptID, ScrollFile + 1, GetEGF!
                            GetEngineGlow = GetEGF!
                        ElseIf SelProperty = egDensity3C Then
                            ScrollFile = ScrollFile + 88
                            Get OptID, ScrollFile + 1, GetEGF!
                            GetEngineGlow = GetEGF!
                        End If
                    End If
                End If
            End If
        End If
    Next
End Function
Public Function GetHitzone(OptID As Variant, MeshNum As Variant, SelProperty As hzProperty) As Variant
    GlobeOffset& = GlobalOffset(OptID)
    MaxMesh = NumMeshes(OptID)
    If MeshNum > MaxMesh Or MeshNum < 1 Then    'if programmer inputs mesh that does not exist...
        Err.Raise vbObjectError + 701, , "Mesh does not exist in OPT"
    End If
    ScrollFile = 22
    Get OptID, ScrollFile + ((MeshNum - 1) * 4) + 1, ZJBMesh&
    ZNumMeshSubs = NumMeshSubs(OptID, MeshNum)
    For ZScrollMeshSubs% = 1 To ZNumMeshSubs
        ScrollFile = ZJBMesh& - GlobeOffset& + 24
        Get OptID, ScrollFile + ((ZScrollMeshSubs% - 1) * 4) + 1, ZJBMeshSub&
        If ZJBMeshSub& <> 0 Then    'if not a null subsection...
            ScrollFile = ZJBMeshSub& - GlobeOffset& + 4
            Get OptID, ScrollFile + 1, ZMeshType&
            If ZMeshType& <> 0 Then     'if other than mesh info(0) block...
               If SelProperty > 17 Or SelProperty < 0 Then  'if programmer inputs property that does not exist...
                    Err.Raise vbObjectError + 722, , "Invalid SelProperty"
                End If
                If ZMeshType& = 25 Then
                    If SelProperty = hzType Then
                        ScrollFile = ScrollFile + 20
                        Get OptID, ScrollFile + 1, GetHZL&
                        Select Case GetHZL&
                            Case 0
                                GetHZS$ = "[0]Default"
                            Case 1
                                GetHZS$ = "[1]MainHull"
                            Case 2
                                GetHZS$ = "[2]Wing"
                            Case 3
                                GetHZS$ = "[3]Fuselage"
                            Case 4
                                GetHZS$ = "[4]GunTurret"
                            Case 5
                                GetHZS$ = "[5]SmallGun"
                            Case 6
                                GetHZS$ = "[6]Engine"
                            Case 7
                                GetHZS$ = "[7]Bridge"
                            Case 8
                                GetHZS$ = "[8]ShieldGen"
                            Case 9
                                GetHZS$ = "[9]EnergyGen"
                            Case 10
                                GetHZS$ = "[10]Launcher"
                            Case 11
                                GetHZS$ = "[11]CommSys"
                            Case 12
                                GetHZS$ = "[12]BeamSys"
                            Case 13
                                GetHZS$ = "[13]CommandBeam"
                            Case 14
                                GetHZS$ = "[14]DockingPlat"
                            Case 15
                                GetHZS$ = "[15]LandingPlat"
                            Case 16
                                GetHZS$ = "[16]Hangar"
                            Case 17
                                GetHZS$ = "[17]CargoPod"
                            Case 18
                                GetHZS$ = "[18]MiscHull"
                            Case 19
                                GetHZS$ = "[19]Antenna"
                            Case 20
                                GetHZS$ = "[20]RotWing"
                            Case 21
                                GetHZS$ = "[21]RotGunTurret"
                            Case 22
                                GetHZS$ = "[22]RotLauncher"
                            Case 23
                                GetHZS$ = "[23]RotCommSys"
                            Case 24
                                GetHZS$ = "[24]RotBeamSys"
                            Case 25
                                GetHZS$ = "[25]RotCommandBeam"
                            Case 26
                                GetHZS$ = "[26]Custom1"
                            Case 27
                                GetHZS$ = "[27]Custom2"
                            Case 28
                                GetHZS$ = "[28]Custom3"
                            Case 29
                                GetHZS$ = "[29]Custom4"
                            Case 30
                                GetHZS$ = "[30]Custom5"
                            Case 31
                                GetHZS$ = "[31]Custom6"
                        End Select
                        GetHitzone = GetHZS$
                    ElseIf SelProperty = hzExpType Then
                        ScrollFile = ScrollFile + 24
                        Get OptID, ScrollFile + 1, GetHZL&
                        GetHitzone = GetHZL&
                    ElseIf SelProperty = hzSpanX Then
                        ScrollFile = ScrollFile + 28
                        Get OptID, ScrollFile + 1, GetHZF!
                        GetHitzone = GetHZF!
                    ElseIf SelProperty = hzSpanY Then
                        ScrollFile = ScrollFile + 32
                        Get OptID, ScrollFile + 1, GetHZF!
                        GetHitzone = GetHZF!
                    ElseIf SelProperty = hzSpanZ Then
                        ScrollFile = ScrollFile + 36
                        Get OptID, ScrollFile + 1, GetHZF!
                        GetHitzone = GetHZF!
                    ElseIf SelProperty = hzCenterX Then
                        ScrollFile = ScrollFile + 40
                        Get OptID, ScrollFile + 1, GetHZF!
                        GetHitzone = GetHZF!
                    ElseIf SelProperty = hzCenterY Then
                        ScrollFile = ScrollFile + 44
                        Get OptID, ScrollFile + 1, GetHZF!
                        GetHitzone = GetHZF!
                    ElseIf SelProperty = hzCenterZ Then
                        ScrollFile = ScrollFile + 48
                        Get OptID, ScrollFile + 1, GetHZF!
                        GetHitzone = GetHZF!
                    ElseIf SelProperty = hzMinX Then
                        ScrollFile = ScrollFile + 52
                        Get OptID, ScrollFile + 1, GetHZF!
                        GetHitzone = GetHZF!
                    ElseIf SelProperty = hzMinY Then
                        ScrollFile = ScrollFile + 56
                        Get OptID, ScrollFile + 1, GetHZF!
                        GetHitzone = GetHZF!
                    ElseIf SelProperty = hzMinZ Then
                        ScrollFile = ScrollFile + 60
                        Get OptID, ScrollFile + 1, GetHZF!
                        GetHitzone = GetHZF!
                    ElseIf SelProperty = hzMaxX Then
                        ScrollFile = ScrollFile + 64
                        Get OptID, ScrollFile + 1, GetHZF!
                        GetHitzone = GetHZF!
                    ElseIf SelProperty = hzMaxY Then
                        ScrollFile = ScrollFile + 68
                        Get OptID, ScrollFile + 1, GetHZF!
                        GetHitzone = GetHZF!
                    ElseIf SelProperty = hzMaxZ Then
                        ScrollFile = ScrollFile + 72
                        Get OptID, ScrollFile + 1, GetHZF!
                        GetHitzone = GetHZF!
                    ElseIf SelProperty = hzTargetID Then
                        ScrollFile = ScrollFile + 76
                        Get OptID, ScrollFile + 1, GetHZL&
                        GetHitzone = GetHZL&
                    ElseIf SelProperty = hzTargetX Then
                        ScrollFile = ScrollFile + 80
                        Get OptID, ScrollFile + 1, GetHZF!
                        GetHitzone = GetHZF!
                    ElseIf SelProperty = hzTargetY Then
                        ScrollFile = ScrollFile + 84
                        Get OptID, ScrollFile + 1, GetHZF!
                        GetHitzone = GetHZF!
                    ElseIf SelProperty = hzTargetZ Then
                        ScrollFile = ScrollFile + 88
                        Get OptID, ScrollFile + 1, GetHZF!
                        GetHitzone = GetHZF!
                    End If
                End If
            End If
        End If
    Next
End Function
Public Function GetRotation(OptID As Variant, MeshNum As Variant, SelProperty As rtProperty) As Single
    GlobeOffset& = GlobalOffset(OptID)
    MaxMesh = NumMeshes(OptID)
    If MeshNum > MaxMesh Or MeshNum < 1 Then    'if programmer inputs mesh that does not exist...
        Err.Raise vbObjectError + 701, , "Mesh does not exist in OPT"
    End If
    ScrollFile = 22
    Get OptID, ScrollFile + ((MeshNum - 1) * 4) + 1, ZJBMesh&
    ZNumMeshSubs = NumMeshSubs(OptID, MeshNum)
    For ZScrollMeshSubs% = 1 To ZNumMeshSubs
        ScrollFile = ZJBMesh& - GlobeOffset& + 24
        Get OptID, ScrollFile + ((ZScrollMeshSubs% - 1) * 4) + 1, ZJBMeshSub&
        If ZJBMeshSub& <> 0 Then    'if not a null subsection...
            ScrollFile = ZJBMeshSub& - GlobeOffset& + 4
            Get OptID, ScrollFile + 1, ZMeshType&
            If ZMeshType& <> 0 Then     'if other than mesh info(0) block...
               If SelProperty > 11 Or SelProperty < 0 Then  'if programmer inputs property that does not exist...
                    Err.Raise vbObjectError + 722, , "Invalid SelProperty"
                End If
                If ZMeshType& = 23 Then
                    If SelProperty = rtPivotX Then
                        ScrollFile = ScrollFile + 20
                    ElseIf SelProperty = rtPivotY Then
                        ScrollFile = ScrollFile + 24
                    ElseIf SelProperty = rtPivotZ Then
                        ScrollFile = ScrollFile + 28
                    ElseIf SelProperty = rtAxisX Then
                        ScrollFile = ScrollFile + 32
                    ElseIf SelProperty = rtAxisY Then
                        ScrollFile = ScrollFile + 36
                    ElseIf SelProperty = rtAxisZ Then
                        ScrollFile = ScrollFile + 40
                    ElseIf SelProperty = rtAimX Then
                        ScrollFile = ScrollFile + 44
                    ElseIf SelProperty = rtAimY Then
                        ScrollFile = ScrollFile + 48
                    ElseIf SelProperty = rtAimZ Then
                        ScrollFile = ScrollFile + 52
                    ElseIf SelProperty = rtDegreeX Then
                        ScrollFile = ScrollFile + 56
                    ElseIf SelProperty = rtDegreeY Then
                        ScrollFile = ScrollFile + 60
                    ElseIf SelProperty = rtDegreeZ Then
                        ScrollFile = ScrollFile + 64
                    End If
                    Get OptID, ScrollFile + 1, GetRotation
                End If
            End If
        End If
    Next
End Function
Public Function GetLOD(OptID As Variant, MeshNum As Variant, LODLevel As Variant) As Single
    GlobeOffset& = GlobalOffset(OptID)
    MaxMesh = NumMeshes(OptID)
    If MeshNum > MaxMesh Or MeshNum < 1 Then    'if programmer inputs mesh that does not exist...
        Err.Raise vbObjectError + 701, , "Mesh does not exist in OPT"
    End If
    ScrollFile = 22
    Get OptID, ScrollFile + ((MeshNum - 1) * 4) + 1, ZJBMesh&
    ZNumMeshSubs = NumMeshSubs(OptID, MeshNum)
    For ZScrollMeshSubs% = 1 To ZNumMeshSubs
        ScrollFile = ZJBMesh& - GlobeOffset& + 24
        Get OptID, ScrollFile + ((ZScrollMeshSubs% - 1) * 4) + 1, ZJBMeshSub&
        If ZJBMeshSub& <> 0 Then    'if not a null subsection...
            ScrollFile = ZJBMeshSub& - GlobeOffset& + 4
            Get OptID, ScrollFile + 1, ZMeshType&
            If ZMeshType& = 0 Then     'if other than mesh info(0) block...
                ScrollFile = ScrollFile + 4
                Get OptID, ScrollFile + 1, ZMeshType&
                If ZMeshType& = 4 Then
                    ScrollFile = ScrollFile + 28
                ElseIf ZMeshType& = 1 Then
                    ScrollFile = ScrollFile + 16
                ElseIf ZMeshType& = 3 Then
                    ScrollFile = ScrollFile + 24
                End If
                Get OptID, ScrollFile + 1, ZJB21Block&
                ScrollFile = ZJB21Block& - GlobeOffset& + 20
                Get OptID, ScrollFile + 1, ZJBFloats&
                MaxValue = NumLODs(OptID, MeshNum)
                If LODLevel > MaxValue Or LODLevel < 1 Then     'if programmer inputs detail level that does not exist...
                    Err.Raise vbObjectError + 716, , "Detail level does not exist in mesh"
                End If
                ScrollFile = ZJBFloats& - GlobeOffset& + (LODLevel - 1) * 4
                Get OptID, ScrollFile + 1, GetLOD   'retrieve visibility distance
            End If
        End If
    Next
End Function
Public Function GetFace(OptID As Variant, MeshNum As Variant, LODNum As Variant, FaceDataNum As Variant, FCSet As Variant, SelProperty As fcProperty) As Variant
    GlobeOffset& = GlobalOffset(OptID)
    MaxMesh = NumMeshes(OptID)
    If MeshNum > MaxMesh Or MeshNum < 1 Then    'if programmer inputs mesh that does not exist...
        Err.Raise vbObjectError + 701, , "Mesh does not exist in OPT"
    End If
    ScrollFile = 22
    Get OptID, ScrollFile + ((MeshNum - 1) * 4) + 1, ZJBMesh&
    ZNumMeshSubs = NumMeshSubs(OptID, MeshNum)
    For ZScrollMeshSubs% = 1 To ZNumMeshSubs
        ScrollFile = ZJBMesh& - GlobeOffset& + 24
        Get OptID, ScrollFile + ((ZScrollMeshSubs% - 1) * 4) + 1, ZJBMeshSub&
        If ZJBMeshSub& <> 0 Then    'if not a null subsection...
            ScrollFile = ZJBMeshSub& - GlobeOffset& + 4
            Get OptID, ScrollFile + 1, ZMeshType&
            If ZMeshType& = 0 Then     'if other than mesh info(0) block...
                ScrollFile = ScrollFile + 4
                Get OptID, ScrollFile + 1, ZMeshType&
                If ZMeshType& = 4 Then
                    ScrollFile = ScrollFile + 28
                ElseIf ZMeshType& = 1 Then
                    ScrollFile = ScrollFile + 16
                ElseIf ZMeshType& = 3 Then
                    ScrollFile = ScrollFile + 24
                End If
                Get OptID, ScrollFile + 1, ZJB21Block&
                 ScrollFile = ZJB21Block& - GlobeOffset& + 8
                 Get OptID, ScrollFile + 1, ZNumLODs&
                 ScrollFile = ZJB21Block& - GlobeOffset& + 12
                 Get OptID, ScrollFile + 1, ZJJLODs&
                MaxLOD = NumLODs(OptID, MeshNum)
                If LODNum > MaxLOD Or LODNum < 1 Then   'if programmer inputs detail level that does not exist...
                    Err.Raise vbObjectError + 703, , "Detail level does not exist in mesh"
                End If
                ScrollFile = ZJJLODs& - GlobeOffset&
                Get OptID, ScrollFile + ((LODNum - 1) * 4) + 1, ZJBLOD&
                ScrollFile = ZJBLOD& - GlobeOffset& + 8
                Get OptID, ScrollFile + 1, ZNumFaceGroups&
               MaxFaceData = NumFaceData(OptID, MeshNum, LODNum)
               If ZScrollMeshes% = MeshNum And ZScrollLODs% = LODNum Then
                   If FaceDataNum > MaxFaceData Or FaceDataNum < 1 Then    'if programmer inputs face data group that does not exist...
                       Err.Raise vbObjectError + 704, , "Face data group does not exist in detail level"
                   End If
               End If
               If SelProperty = fcTexture Then
                   FaceDataNum = FaceDataNum - 1
               End If
                ScrollFile = ZJBLOD& - GlobeOffset& + 24
                Get OptID, ScrollFile + ((FaceDataNum - 1) * 4) + 1, ZJBFaceGroup&
                If ZJBFaceGroup& <> 0 Then      'if not a null face data group...
                    ScrollFile = ZJBFaceGroup& - GlobeOffset& + 4
                    Get OptID, ScrollFile + 1, ZFaceGroupType&
                   MaxFaces = NumFaces(OptID, MeshNum, LODNum, FaceDataNum)
                   If ZScrollMeshes% = MeshNum And ZScrollLODs% = LODNum And ZScrollFaceGroups% = FaceDataNum Then
                       If FCSet > MaxFaces Or FCSet < 1 Then   'if programmer inputs face that does not exist...
                           Err.Raise vbObjectError + 705, , "Face does not exist in face data group"
                       End If
                   End If
                   If SelProperty > 25 Or SelProperty < 0 Then     'if programmer inputs property that does not exist...
                        Err.Raise vbObjectError + 722, , "Invalid SelProperty"
                    End If
                    If SelProperty <> fcTexture Then
                       If ZFaceGroupType& = 1 Then    'if face block(1)
                           ZNumFaces = NumFaces(OptID, MeshNum, LODNum, FaceDataNum)
                           ScrollFile = ScrollFile + 24
                           If SelProperty = fcVertexA Then
                               ScrollFile = ScrollFile + ((FCSet - 1) * 64 + 0 + 0)
                               Get OptID, ScrollFile + 1, GetFCL&
                               GetFace = GetFCL&
                           ElseIf SelProperty = fcVertexB Then
                               ScrollFile = ScrollFile + ((FCSet - 1) * 64 + 0 + 4)
                               Get OptID, ScrollFile + 1, GetFCL&
                               GetFace = GetFCL&
                           ElseIf SelProperty = fcVertexC Then
                               ScrollFile = ScrollFile + ((FCSet - 1) * 64 + 0 + 8)
                               Get OptID, ScrollFile + 1, GetFCL&
                               GetFace = GetFCL&
                           ElseIf SelProperty = fcVertexD Then
                               ScrollFile = ScrollFile + ((FCSet - 1) * 64 + 0 + 12)
                               Get OptID, ScrollFile + 1, GetFCL&
                               GetFace = GetFCL&
                           ElseIf SelProperty = fcEdgeA Then
                               ScrollFile = ScrollFile + ((FCSet - 1) * 64 + 16 + 0)
                               Get OptID, ScrollFile + 1, GetFCL&
                               GetFace = GetFCL&
                           ElseIf SelProperty = fcEdgeB Then
                               ScrollFile = ScrollFile + ((FCSet - 1) * 64 + 16 + 4)
                               Get OptID, ScrollFile + 1, GetFCL&
                               GetFace = GetFCL&
                           ElseIf SelProperty = fcEdgeC Then
                               ScrollFile = ScrollFile + ((FCSet - 1) * 64 + 16 + 8)
                               Get OptID, ScrollFile + 1, GetFCL&
                               GetFace = GetFCL&
                           ElseIf SelProperty = fcEdgeD Then
                               ScrollFile = ScrollFile + ((FCSet - 1) * 64 + 16 + 12)
                               Get OptID, ScrollFile + 1, GetFCL&
                               GetFace = GetFCL&
                           ElseIf SelProperty = fcTexVertexA Then
                               ScrollFile = ScrollFile + ((FCSet - 1) * 64 + 32 + 0)
                               Get OptID, ScrollFile + 1, GetFCL&
                               GetFace = GetFCL&
                           ElseIf SelProperty = fcTexVertexB Then
                               ScrollFile = ScrollFile + ((FCSet - 1) * 64 + 32 + 4)
                               Get OptID, ScrollFile + 1, GetFCL&
                               GetFace = GetFCL&
                           ElseIf SelProperty = fcTexVertexC Then
                               ScrollFile = ScrollFile + ((FCSet - 1) * 64 + 32 + 8)
                               Get OptID, ScrollFile + 1, GetFCL&
                               GetFace = GetFCL&
                           ElseIf SelProperty = fcTexVertexD Then
                               ScrollFile = ScrollFile + ((FCSet - 1) * 64 + 32 + 12)
                               Get OptID, ScrollFile + 1, GetFCL&
                               GetFace = GetFCL&
                           ElseIf SelProperty = fcVertexNormalA Then
                               ScrollFile = ScrollFile + ((FCSet - 1) * 64 + 48 + 0)
                               Get OptID, ScrollFile + 1, GetFCL&
                               GetFace = GetFCL&
                           ElseIf SelProperty = fcVertexNormalB Then
                               ScrollFile = ScrollFile + ((FCSet - 1) * 64 + 48 + 4)
                               Get OptID, ScrollFile + 1, GetFCL&
                               GetFace = GetFCL&
                           ElseIf SelProperty = fcVertexNormalC Then
                               ScrollFile = ScrollFile + ((FCSet - 1) * 64 + 48 + 8)
                               Get OptID, ScrollFile + 1, GetFCL&
                               GetFace = GetFCL&
                           ElseIf SelProperty = fcVertexNormalD Then
                               ScrollFile = ScrollFile + ((FCSet - 1) * 64 + 48 + 12)
                               Get OptID, ScrollFile + 1, GetFCL&
                               GetFace = GetFCL&
                           ElseIf SelProperty = fcI Then
                               ScrollFile = ScrollFile + (ZNumFaces * 64 + (FCSet - 1) * 12 + 0)
                               Get OptID, ScrollFile + 1, GetFCF!
                               GetFace = GetFCF!
                           ElseIf SelProperty = fcJ Then
                               ScrollFile = ScrollFile + (ZNumFaces * 64 + (FCSet - 1) * 12 + 4)
                               Get OptID, ScrollFile + 1, GetFCF!
                               GetFace = GetFCF!
                           ElseIf SelProperty = fcK Then
                               ScrollFile = ScrollFile + (ZNumFaces * 64 + (FCSet - 1) * 12 + 8)
                               Get OptID, ScrollFile + 1, GetFCF!
                               GetFace = GetFCF!
                           ElseIf SelProperty = fc1X Then
                               ScrollFile = ScrollFile + (ZNumFaces * 64 + ZNumFaces * 12 + (FCSet - 1) * 24 + 0)
                               Get OptID, ScrollFile + 1, GetFCF!
                               GetFace = GetFCF!
                           ElseIf SelProperty = fc1Y Then
                               ScrollFile = ScrollFile + (ZNumFaces * 64 + ZNumFaces - 1 * 12 + (FCSet - 1) * 24 + 4)
                               Get OptID, ScrollFile + 1, GetFCF!
                               GetFace = GetFCF!
                           ElseIf SelProperty = fc1Z Then
                               ScrollFile = ScrollFile + (ZNumFaces * 64 + ZNumFaces * 12 + (FCSet - 1) * 24 + 8)
                               Get OptID, ScrollFile + 1, GetFCF!
                               GetFace = GetFCF!
                            ElseIf SelProperty = fc2X Then
                               ScrollFile = ScrollFile + (ZNumFaces * 64 + ZNumFaces * 12 + (FCSet - 1) * 24 + 12)
                               Get OptID, ScrollFile + 1, GetFCF!
                               GetFace = GetFCF!
                           ElseIf SelProperty = fc2Y Then
                               ScrollFile = ScrollFile + (ZNumFaces * 64 + ZNumFaces * 12 + (FCSet - 1) * 24 + 16)
                               Get OptID, ScrollFile + 1, GetFCF!
                               GetFace = GetFCF!
                           ElseIf SelProperty = fc2Z Then
                               ScrollFile = ScrollFile + (ZNumFaces * 64 + ZNumFaces * 12 + (FCSet - 1) * 24 + 20)
                               Get OptID, ScrollFile + 1, GetFCF!
                               GetFace = GetFCF!
                           End If
                       End If
                    ElseIf SelProperty = fcTexture Then
                       If ZFaceGroupType& = 20 Then    'if texture block(20)
                           ScrollFile = ZJBFaceGroup& - GlobeOffset& + 24
                           Seek OptID, ScrollFile + 1
                           GetFCS$ = Input$(8, OptID)
                           GetFace = GetFCS$
                       ElseIf ZFaceGroupType& = 24 Then    'if texture block(24)
                           ScrollFile = ScrollFile + 4
                           Get OptID, ScrollFile + 1, ZFaceGroupType&
                           If ZFaceGroupType& <> 1 Then    'if texture block(24) C or CCC
                               ScrollFile = ScrollFile + 8
                               Get OptID, ScrollFile + 1, ZFaceGroupType&
                               If ZFaceGroupType& = 1 Then 'if texture block(24) CC
                                   ScrollFile = ZJBFaceGroup& - GlobeOffset& + 8
                                   Get OptID, ScrollFile + 1, ZNumFaceFaceGroups&
                                   For ZScrollFaceFaceGroups% = 1 To 1
                                       ScrollFile = ZJBFaceGroup& - GlobeOffset& + 24
                                       Get OptID, ScrollFile + ((ZScrollFaceFaceGroups% - 1) * 4) + 1, ZJBFaceFaceGroup&
                                       ScrollFile = ZJBFaceFaceGroup& - GlobeOffset& + 4
                                       Get OptID, ScrollFile + 1, ZFaceFaceGroupType&
                                       If ZFaceFaceGroupType& = 20 Then    'if texture block(20)
                                           ScrollFile = ZJBFaceFaceGroup& - GlobeOffset& + 24
                                           Seek OptID, ScrollFile + 1
                                           GetFCS$ = Input$(8, OptID)
                                           GetFace = GetFCS$
                                       End If
                                   Next
                               ElseIf ZFaceGroupType& = 0 Then     'if texture block(24) CCC
                                   ScrollFile = ZJBFaceGroup& - GlobeOffset& + 8
                                   Get OptID, ScrollFile + 1, ZNumFaceFaceGroups&
                                   For ZScrollFaceFaceGroups = 1 To 1
                                       ScrollFile = ZJBFaceGroup& - GlobeOffset& + 24
                                       Get OptID, ScrollFile + ((ZScrollFaceFaceGroups - 1) * 4) + 1, ZJBFaceFaceGroup&
                                       ScrollFile = ZJBFaceFaceGroup& - GlobeOffset& + 4
                                       Get OptID, ScrollFile + 1, ZFaceFaceGroupType&
                                       If ZFaceFaceGroupType& = 20 Then    'if texture block(20) AAA
                                           ScrollFile = ZJBFaceFaceGroup& - GlobeOffset& + 24
                                           Seek OptID, ScrollFile + 1
                                           GetFCS$ = Input$(8, OptID)
                                           GetFace = GetFCS$
                                       End If
                                   Next
                               End If
                           ElseIf ZFaceGroupType& = 1 Then     'if texture block(24) CC
                               ScrollFile = ZJBFaceGroup& - GlobeOffset& + 24
                               Get OptID, ScrollFile + 1, ZJBFaceFaceGroup&
                               ScrollFile = ZJBFaceFaceGroup& - GlobeOffset& + 24
                               Seek OptID, ScrollFile + 1
                               GetFCS$ = Input$(8, OptID)
                               GetFace = GetFCS$
                           End If
                       End If
                    End If
                End If
            End If
        End If
    Next
End Function
Public Function GetTexture(OptID As Variant, TextureName As String) As StdPicture
    TexFound = 0    'texture not found yet
    GlobeOffset& = GlobalOffset(OptID)
    ZNumMeshes = NumMeshes(OptID)
    For ZScrollMeshes% = 1 To ZNumMeshes
        ScrollFile = 22
        Get OptID, ScrollFile + ((ZScrollMeshes% - 1) * 4) + 1, ZJBMesh&
        ZNumMeshSubs = NumMeshSubs(OptID, ZScrollMeshes%)
        For ZScrollMeshSubs% = 1 To ZNumMeshSubs
            ScrollFile = ZJBMesh& - GlobeOffset& + 24
            Get OptID, ScrollFile + ((ZScrollMeshSubs% - 1) * 4) + 1, ZJBMeshSub&
            If ZJBMeshSub& <> 0 Then
                ScrollFile = ZJBMeshSub& - GlobeOffset& + 4
                Get OptID, ScrollFile + 1, ZMeshType&
                If ZMeshType& = 0 Then     'if mesh info(0) block...
                    ScrollFile = ScrollFile + 4
                    Get OptID, ScrollFile + 1, ZMeshType&
                    If ZMeshType& = 4 Then
                        ScrollFile = ScrollFile + 28
                    ElseIf ZMeshType& = 1 Then
                        ScrollFile = ScrollFile + 16
                    ElseIf ZMeshType& = 3 Then
                        ScrollFile = ScrollFile + 24
                    End If
                    Get OptID, ScrollFile + 1, ZJB21Block&
                     ScrollFile = ZJB21Block& - GlobeOffset& + 8
                     Get OptID, ScrollFile + 1, ZNumLODs&
                     ScrollFile = ZJB21Block& - GlobeOffset& + 12
                     Get OptID, ScrollFile + 1, ZJJLODs&
                     For ZScrollLODs% = 1 To ZNumLODs&
                         ScrollFile = ZJJLODs& - GlobeOffset&
                         Get OptID, ScrollFile + ((ZScrollLODs% - 1) * 4) + 1, ZJBLOD&
                         ScrollFile = ZJBLOD& - GlobeOffset& + 8
                         Get OptID, ScrollFile + 1, ZNumFaceGroups&
                         For ZScrollFaceGroups% = 1 To ZNumFaceGroups&
                             ScrollFile = ZJBLOD& - GlobeOffset& + 24
                             Get OptID, ScrollFile + ((ZScrollFaceGroups% - 1) * 4) + 1, ZJBFaceGroup&
                             If ZJBFaceGroup& <> 0 Then      'if not a null face data group
                                 ScrollFile = ZJBFaceGroup& - GlobeOffset& + 4
                                 Get OptID, ScrollFile + 1, ZFaceGroupType&
                                 If ZFaceGroupType& = 20 Then    'if texture block(20)
                                     ScrollFile = ZJBFaceGroup& - GlobeOffset& + 24
                                     Seek OptID, ScrollFile + 1
                                     CheckName$ = Input$(8, OptID)
                                     If UCase$(CheckName$) = UCase$(TextureName) Then
                                         TexFound = 1   'texture found
                                         ScrollFile = ScrollFile - 24 + 8
                                         Get OptID, ScrollFile + 1, ZFaceGroupType&
                                         If ZFaceGroupType& = 0 Then    'if type AAA texture block(20)
                                             ScrollFile = ScrollFile + 25
                                             Get OptID, ScrollFile + 1, JBPalette&
                                             ScrollFile = ScrollFile + 8
                                             Get OptID, ScrollFile + 1, ImgSize&
                                             ScrollFile = ScrollFile + 8
                                             Get OptID, ScrollFile + 1, ImgWidth&
                                             ScrollFile = ScrollFile + 4
                                             Get OptID, ScrollFile + 1, ImgHeight&
                                             ScrollFile = ScrollFile + 4
                                             Seek OptID, ScrollFile + 1
                                             TexData$ = Input$(ImgSize&, OptID)     'retrieve texture data
                                             ScrollFile = JBPalette& - GlobeOffset& + 3584
                                            Seek OptID, ScrollFile + 1
                                            PalData$ = Input$(256 * 2, OptID)   'retrieve palette data
                                             Call BMPWriter(PalData$, TexData$, ImgSize&, ImgWidth&, ImgHeight&)
                                             Set GetTexture = LoadPicture(CurDir$ & "\TEMP.BMP")
                                             Kill CurDir$ & "\TEMP.BMP"
                                         ElseIf ZFaceGroupType& = 1 Then 'if type AA texture block(20)
                                             ScrollFile = ScrollFile + 29
                                             Get OptID, ScrollFile + 1, JBPalette&
                                             ScrollFile = ScrollFile + 8
                                             Get OptID, ScrollFile + 1, ImgSize&
                                             ScrollFile = ScrollFile + 8
                                             Get OptID, ScrollFile + 1, ImgWidth&
                                             ScrollFile = ScrollFile + 4
                                             Get OptID, ScrollFile + 1, ImgHeight&
                                             ScrollFile = ScrollFile + 4
                                             Seek OptID, ScrollFile + 1
                                             TexData$ = Input$(ImgSize&, OptID)     'retrieve texture data
                                             ScrollFile = JBPalette& - GlobeOffset& + 3584
                                            Seek OptID, ScrollFile + 1
                                             PalData$ = Input$(256 * 2, OptID)  'retrieve palette data
                                             Call BMPWriter(PalData$, TexData$, ImgSize&, ImgWidth&, ImgHeight&)
                                             Set GetTexture = LoadPicture(CurDir$ & "\TEMP.BMP")
                                             Kill CurDir$ & "\TEMP.BMP"
                                         End If
                                     End If
                                 ElseIf ZFaceGroupType& = 24 Then    'if texture block(24)
                                     ScrollFile = ScrollFile + 4
                                     Get OptID, ScrollFile + 1, ZFaceGroupType&
                                     If ZFaceGroupType& <> 1 Then    'if texture block(24) C or CCC
                                         ScrollFile = ScrollFile + 8
                                         Get OptID, ScrollFile + 1, ZFaceGroupType&
                                         If ZFaceGroupType& = 1 Then 'if texture block(24) CC
                                             ScrollFile = ZJBFaceGroup& - GlobeOffset& + 8
                                             Get OptID, ScrollFile + 1, ZNumFaceFaceGroups&
                                             For ZScrollFaceFaceGroups = 1 To ZNumFaceFaceGroups&
                                                 ScrollFile = ZJBFaceGroup& - GlobeOffset& + 24
                                                 Get OptID, ScrollFile + ((ZScrollFaceFaceGroups - 1) * 4) + 1, ZJBFaceFaceGroup&
                                                 ScrollFile = ZJBFaceFaceGroup& - GlobeOffset& + 4
                                                 Get OptID, ScrollFile + 1, ZFaceFaceGroupType&
                                                 If ZFaceFaceGroupType& = 20 Then    'if texture block(20)
                                                     ScrollFile = ZJBFaceFaceGroup& - GlobeOffset& + 24
                                                     Seek OptID, ScrollFile + 1
                                                     CheckName$ = Input$(8, OptID)
                                                     If UCase$(CheckName$) = UCase$(TextureName) Then
                                                         TexFound = 1   'texture found
                                                         ScrollFile = ScrollFile - 24 + 8
                                                         Get OptID, ScrollFile + 1, ZFaceFaceGroupType&
                                                         If ZFaceFaceGroupType& = 0 Then    'if type AAA texture block(20)
                                                             ScrollFile = ScrollFile + 25
                                                             Get OptID, ScrollFile + 1, JBPalette&
                                                             ScrollFile = ScrollFile + 8
                                                             Get OptID, ScrollFile + 1, ImgSize&
                                                             ScrollFile = ScrollFile + 8
                                                             Get OptID, ScrollFile + 1, ImgWidth&
                                                             ScrollFile = ScrollFile + 4
                                                             Get OptID, ScrollFile + 1, ImgHeight&
                                                             ScrollFile = ScrollFile + 4
                                                             Seek OptID, ScrollFile + 1
                                                             TexData$ = Input$(ImgSize&, OptID)     'retrieve texture data
                                                             ScrollFile = JBPalette& - GlobeOffset& + 3584
                                                            Seek OptID, ScrollFile + 1
                                                             PalData$ = Input$(256 * 2, OptID)  'retrieve palette data
                                                            Call BMPWriter(PalData$, TexData$, ImgSize&, ImgWidth&, ImgHeight&)
                                                            Set GetTexture = LoadPicture(CurDir$ & "\TEMP.BMP")
                                                            Kill CurDir$ & "\TEMP.BMP"
                                                         ElseIf ZFaceFaceGroupType& = 1 Then 'if type AA texture block(20)
                                                             ScrollFile = ScrollFile + 29
                                                             Get OptID, ScrollFile + 1, JBPalette&
                                                             ScrollFile = ScrollFile + 8
                                                             Get OptID, ScrollFile + 1, ImgSize&
                                                             ScrollFile = ScrollFile + 8
                                                             Get OptID, ScrollFile + 1, ImgWidth&
                                                             ScrollFile = ScrollFile + 4
                                                             Get OptID, ScrollFile + 1, ImgHeight&
                                                             ScrollFile = ScrollFile + 4
                                                             Seek OptID, ScrollFile + 1
                                                             TexData$ = Input$(ImgSize&, OptID)     'retrieve texture data
                                                             ScrollFile = JBPalette& - GlobeOffset& + 3584
                                                            Seek OptID, ScrollFile + 1
                                                             PalData$ = Input$(256 * 2, OptID)  'retrieve palette data...
                                                            Call BMPWriter(PalData$, TexData$, ImgSize&, ImgWidth&, ImgHeight&)
                                                            Set GetTexture = LoadPicture(CurDir$ & "\TEMP.BMP")
                                                            Kill CurDir$ & "\TEMP.BMP"
                                                         End If
                                                     End If
                                                 End If
                                             Next
                                         ElseIf ZFaceGroupType& = 0 Then     'if texture block(24) CCC
                                             ScrollFile = ZJBFaceGroup& - GlobeOffset& + 8
                                             Get OptID, ScrollFile + 1, ZNumFaceFaceGroups&
                                             For ZScrollFaceFaceGroups = 1 To ZNumFaceFaceGroups&
                                                 ScrollFile = ZJBFaceGroup& - GlobeOffset& + 24
                                                 Get OptID, ScrollFile + ((ZScrollFaceFaceGroups - 1) * 4) + 1, ZJBFaceFaceGroup&
                                                 ScrollFile = ZJBFaceFaceGroup& - GlobeOffset& + 4
                                                 Get OptID, ScrollFile + 1, ZFaceFaceGroupType&
                                                 If ZFaceFaceGroupType& = 20 Then    'if texture block(20)
                                                     ScrollFile = ZJBFaceFaceGroup& - GlobeOffset& + 24
                                                     Seek OptID, ScrollFile + 1
                                                     CheckName$ = Input$(8, OptID)
                                                     If UCase$(CheckName$) = UCase$(TextureName) Then
                                                         TexFound = 1   'texture found
                                                         ScrollFile = ScrollFile - 24 + 8
                                                         Get OptID, ScrollFile + 1, ZFaceFaceGroupType&
                                                         If ZFaceFaceGroupType& = 0 Then    'if type AAA texture block(20)
                                                             ScrollFile = ScrollFile + 25
                                                             Get OptID, ScrollFile + 1, JBPalette&
                                                             ScrollFile = ScrollFile + 8
                                                             Get OptID, ScrollFile + 1, ImgSize&
                                                             ScrollFile = ScrollFile + 8
                                                             Get OptID, ScrollFile + 1, ImgWidth&
                                                             ScrollFile = ScrollFile + 4
                                                             Get OptID, ScrollFile + 1, ImgHeight&
                                                             ScrollFile = ScrollFile + 4
                                                             Seek OptID, ScrollFile + 1
                                                             TexData$ = Input$(ImgSize&, OptID)     'retrieve texture data
                                                             ScrollFile = JBPalette& - GlobeOffset& + 3584
                                                            Seek OptID, ScrollFile + 1
                                                             PalData$ = Input$(256 * 2, OptID)  'retrieve palette data
                                                            Call BMPWriter(PalData$, TexData$, ImgSize&, ImgWidth&, ImgHeight&)
                                                            Set GetTexture = LoadPicture(CurDir$ & "\TEMP.BMP")
                                                            Kill CurDir$ & "\TEMP.BMP"
                                                         ElseIf ZFaceFaceGroupType& = 1 Then 'if type AA texture block(20)
                                                             ScrollFile = ScrollFile + 29
                                                             Get OptID, ScrollFile + 1, JBPalette&
                                                             ScrollFile = ScrollFile + 8
                                                             Get OptID, ScrollFile + 1, ImgSize&
                                                             ScrollFile = ScrollFile + 8
                                                             Get OptID, ScrollFile + 1, ImgWidth&
                                                             ScrollFile = ScrollFile + 4
                                                             Get OptID, ScrollFile + 1, ImgHeight&
                                                             ScrollFile = ScrollFile + 4
                                                             Seek OptID, ScrollFile + 1
                                                             TexData$ = Input$(ImgSize&, OptID)     'retrieve texture data
                                                             ScrollFile = JBPalette& - GlobeOffset& + 3584
                                                            Seek OptID, ScrollFile + 1
                                                             PalData$ = Input$(256 * 2, OptID)  'retrieve palette data
                                                            Call BMPWriter(PalData$, TexData$, ImgSize&, ImgWidth&, ImgHeight&)
                                                            Set GetTexture = LoadPicture(CurDir$ & "\TEMP.BMP")
                                                            Kill CurDir$ & "\TEMP.BMP"
                                                         End If
                                                     End If
                                                 End If
                                             Next
                                         End If
                                     ElseIf ZFaceGroupType& = 1 Then     'if texture block(24) CC
                                         ScrollFile = ZJBFaceGroup& - GlobeOffset& + 24
                                         Get OptID, ScrollFile + 1, ZJBFaceFaceGroup&
                                         ScrollFile = ZJBFaceFaceGroup& - GlobeOffset& + 24
                                         Seek OptID, ScrollFile + 1
                                         CheckName$ = Input$(8, OptID)
                                         If UCase$(CheckName$) = UCase$(TextureName) Then
                                            TexFound = 1    'texture found
                                            ScrollFile = ScrollFile - 24 + 8
                                            Get OptID, ScrollFile + 1, ZFaceFaceGroupType&
                                            If ZFaceFaceGroupType& = 0 Then    'if type AAA texture block(20)
                                                ScrollFile = ScrollFile + 25
                                                Get OptID, ScrollFile + 1, JBPalette&
                                                ScrollFile = ScrollFile + 8
                                                Get OptID, ScrollFile + 1, ImgSize&
                                                ScrollFile = ScrollFile + 8
                                                Get OptID, ScrollFile + 1, ImgWidth&
                                                ScrollFile = ScrollFile + 4
                                                Get OptID, ScrollFile + 1, ImgHeight&
                                                ScrollFile = ScrollFile + 4
                                                Seek OptID, ScrollFile + 1
                                                TexData$ = Input$(ImgSize&, OptID)  'retrieve texture data
                                                ScrollFile = JBPalette& - GlobeOffset& + 3584
                                                Seek OptID, ScrollFile + 1
                                                PalData$ = Input$(256 * 2, OptID)   'retrieve palette data
                                               Call BMPWriter(PalData$, TexData$, ImgSize&, ImgWidth&, ImgHeight&)
                                               Set GetTexture = LoadPicture(CurDir$ & "\TEMP.BMP")
                                               Kill CurDir$ & "\TEMP.BMP"
                                            ElseIf ZFaceFaceGroupType& = 1 Then 'if type AA texture block(20)
                                                ScrollFile = ScrollFile + 29
                                                Get OptID, ScrollFile + 1, JBPalette&
                                                ScrollFile = ScrollFile + 8
                                                Get OptID, ScrollFile + 1, ImgSize&
                                                ScrollFile = ScrollFile + 8
                                                Get OptID, ScrollFile + 1, ImgWidth&
                                                ScrollFile = ScrollFile + 4
                                                Get OptID, ScrollFile + 1, ImgHeight&
                                                ScrollFile = ScrollFile + 4
                                                Seek OptID, ScrollFile + 1
                                                TexData$ = Input$(ImgSize&, OptID)  'retrieve texture data
                                                ScrollFile = JBPalette& - GlobeOffset& + 3584
                                                Seek OptID, ScrollFile + 1
                                                PalData$ = Input$(256 * 2, OptID)   'retrieve palette data
                                               Call BMPWriter(PalData$, TexData$, ImgSize&, ImgWidth&, ImgHeight&)
                                               Set GetTexture = LoadPicture(CurDir$ & "\TEMP.BMP")
                                               Kill CurDir$ & "\TEMP.BMP"
                                            End If
                                         End If
                                     End If
                                 End If
                             End If
                         Next
                     Next
                End If
            End If
        Next
    Next
    If TexFound = 0 Then    'if programmer inputs texture that does not exist...
        Err.Raise vbObjectError + 717, , "Texture does not exist in OPT"
    End If
End Function
Private Sub BMPWriter(PaletteData As String, TextureData As String, ImageSize As Long, ImageWidth As Long, ImageHeight As Long)
    Open CurDir$ & "\TEMP.BMP" For Binary As #201
        NewData% = 19778
        Put #201, , NewData%
        NewDataL& = -1234
        Put #201, , NewDataL&
        NewData% = 0
        Put #201, , NewData%
        Put #201, , NewData%
        NewDataL& = 1078
        Put #201, , NewDataL&
        NewDataL& = 40
        Put #201, , NewDataL&
        Put #201, , ImageWidth&
        Put #201, , ImageHeight&
        NewData% = 1
        Put #201, , NewData%
        NewDataL& = 8
        Put #201, , NewDataL&
        For I = 1 To 11
            NewData% = 0
            Put #201, , NewData%
        Next
        For I = 1 To 511 Step 2
            PalByteA$ = Mid$(PaletteData$, I, 1)
            PalByteB$ = Mid$(PaletteData$, I + 1, 1)
            PalByte1% = Asc(PalByteA$)
            PalByte2% = Asc(PalByteB$)
            BitString$ = DecToBin(PalByte1%, 1, 16)
            ColorBin$ = BitString$
            BitString$ = DecToBin(PalByte2%, 1, 16)
            ColorBin$ = BinBuffer(ColorBin$, 8)
            BitString$ = BinBuffer(BitString$, 8)
            ColorBin$ = BitString$ & ColorBin$
            TempColorBin$ = ColorBin$
            DecVal% = BinToDec(ColorBin$, 1, 5)
            ColorBin$ = TempColorBin$
            RedCol = DecVal%
            RedCol = RedCol * 256 / 32
            RedColor$ = Chr$(RedCol)
            DecVal% = BinToDec(ColorBin$, 6, 6)
            ColorBin$ = TempColorBin$
            GreenCol = DecVal%
            GreenCol = GreenCol * 256 / 64
            GreenColor$ = Chr$(GreenCol)
            DecVal% = BinToDec(ColorBin$, 12, 5)
            ColorBin$ = TempColorBin$
            BlueCol = DecVal%
            BlueCol = BlueCol * 256 / 32
            BlueColor$ = Chr$(BlueCol)
            Put #201, , BlueColor$
            Put #201, , GreenColor$
            Put #201, , RedColor$
            NewDataB$ = Chr$(0)
            Put #201, , NewDataB$
        Next
        Put #201, , TextureData$
        Put #201, 2 + 1, LOF(7)
    Close #201
End Sub
Private Function BinBuffer(BitVal As String, NumBits As Integer) As String
    ZeroBuffers = Len(BitVal$)
    For I = 1 To NumBits% - ZeroBuffers
        BitVal$ = "0" & BitVal$
    Next
    BinBuffer = BitVal$
End Function
Private Function BinToDec(BitVal As String, BitStart As Integer, NumBits As Integer) As Integer
    BitVal$ = Mid$(BitVal$, BitStart, NumBits)
    ZeroBuffers = Len(BitVal$)
    For I = 1 To 16 - NumBits%
        BitVal$ = "0" & BitVal$
    Next
    BinToDec = 0
    For ScrollBits = 1 To NumBits%
        CheckBit$ = Mid$(BitVal$, 16 - NumBits% + ScrollBits, 1)
        If CheckBit$ = "1" Then
            BinToDec = BinToDec + 2 ^ (NumBits% - ScrollBits)
        End If
    Next
End Function
Private Function DecToBin(DecVal As Integer, BitStart As Integer, NumBits As Integer) As String
    DecToBin = "0000000000000000"
    For ScrollBits = BitStart% To (BitStart% + NumBits% - 1)
        ExponentInc = 0
        GoOn = 1
        Do While GoOn = 1
            If 2 ^ ExponentInc <= DecVal% Then
                Parent1Val = 2 ^ ExponentInc
                ExponentInc = ExponentInc + 1
            Else
                GoOn = 0
            End If
        Loop
        If DecVal% <> 0 Then
            Mid$(DecToBin, 16 - ExponentInc + 1, 1) = 1
            DecVal% = DecVal% - Parent1Val
        End If
    Next
    Do
        BitCheck$ = Left$(DecToBin, 1)
        If BitCheck$ = "0" Then
            DecToBin = Right$(DecToBin, Len(DecToBin) - 1)
        End If
    Loop While BitCheck$ = "0"
End Function



